﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoE_MxFilterGen.compiler
{   
    public class Block
    {
        public string Type { get; set; }
        public bool Show { get; set; }
        public List<string> Class { get; set; }
        public List<string> BaseType { get; set; }
        public string SetTextColor { get; set; }
        public string SetBackgroundColor { get; set; }
        public string SetBorderColor { get; set; }
        public string SetFontSize { get; set; }
        public List<Condition> Conditions { get; set; }
        public List<Action> Actions { get; set; }
    }

    public class Condition
    {
        public string name { get; set; }
        public string op { get; set; }
        public string value { get; set; }
    }

    public class Action
    {
        public string name { get; set; }
        public string va { get; set; }
        public object vb { get; set; }
        public object vc { get; set; }
        public object vd { get; set; }
    }

    public class RootBlocks
    {
        public List<Block> blocks { get; set; }
    }
    internal class section
    {
        public static string outpath = "out/filson.filter";
        private static string iC;
        private static string iB;
        public static void Compile()
        {
            if (File.Exists(outpath)) { File.Delete("out/filson.filter"); }
            ////////// Splash //////////
            File.AppendAllText(outpath, $"#### Filson - PoE Item Filter JSON Parsing - MxFilterGen v{main.version}{Environment.NewLine}");
            File.AppendAllText(outpath, $"#### Filson and MxFilterGen are developped by mikx.{Environment.NewLine}");
            File.AppendAllText(outpath, $"#### MxGit:     https://mxgit.ovh/mikx/PoE-MxFilterGen{Environment.NewLine}");
            File.AppendAllText(outpath, $"#### MxPoE:     https://mxpoe.ovh/{Environment.NewLine}");
            File.AppendAllText(outpath, $"#### Contact:   mikx@mxpoe.ovh / http://discord.mxg.ovh{Environment.NewLine}");
            foreach (Block bl in JsonConvert.DeserializeObject<RootBlocks>(File.ReadAllText("filson/LEVELING.json", Encoding.UTF8)).blocks)
            {               
                ////////// Skip a line //////////
                File.AppendAllText(outpath, Environment.NewLine);
                ////////// Show or Hide //////////
                string bshow = "";
                if (bl.Show) { bshow = "Show"; } else { bshow = "Hide"; };
                File.AppendAllText(outpath, bshow + Environment.NewLine);
                ////////// Class //////////
                if (bl.Class[0] != null) {
                    foreach (var c in bl.Class) { iC += string.Format(@" ""{0}""", c); }
                    File.AppendAllText(outpath, $"    Class {iC} {Environment.NewLine}");
                }
                ////////// Base //////////
                if (bl.BaseType[0] != null)
                {
                    foreach (var b in bl.BaseType) { iB += string.Format(@" ""{0}""", b); }
                    File.AppendAllText(outpath, $"    BaseType {iB} {Environment.NewLine}");
                }
                ////////// SetTextColor //////////
                if (bl.SetTextColor != null)
                {
                    File.AppendAllText(outpath, $"    SetTextColor {bl.SetTextColor} {Environment.NewLine}");
                }
                ////////// SetBackgroundColor //////////
                if (bl.SetBackgroundColor != null)
                {                   
                    File.AppendAllText(outpath, $"    SetBackgroundColor {bl.SetBackgroundColor} {Environment.NewLine}");
                }
                ////////// SetBorderColor //////////
                if (bl.SetBorderColor != null)
                {                    
                    File.AppendAllText(outpath, $"    SetBorderColor {bl.SetBorderColor} {Environment.NewLine}");
                }
                ////////// SetFontSize //////////
                File.AppendAllText(outpath, "    SetFontSize " + bl.SetFontSize + Environment.NewLine);
                ////////// Conditions //////////
                foreach (var con in bl.Conditions)
                {
                    string cn;
                    string co;
                    string cv;
                    switch (con.name)
                    {
                        case "ItemLevel":
                            cn = con.name;
                            co = con.op;
                            cv = con.value;
                            File.AppendAllText(outpath, $"    {cn} {co} {cv} {Environment.NewLine}");
                            break;
                        case "Rarity":
                            cn = con.name;
                            co = con.op;
                            cv = con.value;
                            File.AppendAllText(outpath, $"    {cn} {cv} {Environment.NewLine}");
                            break;
                    }
                }
                ////////// Actions //////////
                foreach (var ac in bl.Actions)
                {
                    string an;
                    string ava;
                    switch (ac.name)
                    {
                        case "CustomAlertSound":
                            an = ac.name;
                            ava = ac.va;
                            File.AppendAllText(outpath, $"    {an} \"{ava}\" {Environment.NewLine}");
                            break;
                    }
                }
                iB = "";
                iC = "";
            }
        }
    }
}
