﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoE_MxFilterGen
{
    public class CurrencyDetail
    {
        public int id { get; set; }
        public string icon { get; set; }
        public string name { get; set; }
        public string tradeId { get; set; }
    }

    public class LanguageCurrency
    {
        public string name { get; set; }
        public Translations translations { get; set; }
    }

    public class LineCurrency
    {
        public string currencyTypeName { get; set; }
        public Pay pay { get; set; }
        public Receive receive { get; set; }
        public double chaosEquivalent { get; set; }
        public LowConfidencePaySparkLine lowConfidencePaySparkLine { get; set; }
        public LowConfidenceReceiveSparkLine lowConfidenceReceiveSparkLine { get; set; }
        public string detailsId { get; set; }
    }

    public class LowConfidencePaySparkLine
    {
        public List<object> data { get; set; }
        public double totalChange { get; set; }
    }

    public class LowConfidenceReceiveSparkLine
    {
        public List<double?> data { get; set; }
        public double totalChange { get; set; }
    }

    public class Pay
    {
        public int id { get; set; }
        public int league_id { get; set; }
        public int pay_currency_id { get; set; }
        public int get_currency_id { get; set; }
        public DateTime sample_time_utc { get; set; }
        public int count { get; set; }
        public double value { get; set; }
        public int data_point_count { get; set; }
        public bool includes_secondary { get; set; }
        public int listing_count { get; set; }
    }

    public class PaySparkLine
    {
        public List<object> data { get; set; }
        public double totalChange { get; set; }
    }

    public class Receive
    {
        public int id { get; set; }
        public int league_id { get; set; }
        public int pay_currency_id { get; set; }
        public int get_currency_id { get; set; }
        public DateTime sample_time_utc { get; set; }
        public int count { get; set; }
        public double value { get; set; }
        public int data_point_count { get; set; }
        public bool includes_secondary { get; set; }
        public int listing_count { get; set; }
    }

    public class ReceiveSparkLine
    {
        public List<double> data { get; set; }
        public double totalChange { get; set; }
    }

    public class RootCurrency
    {
        public List<LineCurrency> lines { get; set; }
        public List<CurrencyDetail> currencyDetails { get; set; }
        public LanguageCurrency language { get; set; }
    }

    public class TranslationsCurrency
    {
    }
}
