﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Linq;

namespace PoE_MxFilterGen.generator
{   
    internal class tier
    {
        private static string iB;
        private static List<string> iBA = new List<string>();
        private static string iBInt;
        private static List<string> iBIntA = new List<string>();
        private static string iBStr;
        private static List<string> iBStrA = new List<string>();
        private static string iBDex;
        private static List<string> iBDexA = new List<string>();

        public static string[] Int()
        {
            string[] Int = new string[] {
                "Wand",
                "Sorcerer",
                "Mind",
                "Bone",
                "Silk",
                "Arcanist",
                "Spirit",
                "Solaris",
                "Slippers",
                "Samite",
                "Demon's Horn",
                "Conjurer Gloves",
                "Slaughter Knife",
                "Deicide",
                "Conjurer",
                "Necromancer",
                "Deicide",
                "Platinum Kris",
                "Zealot Boots",
                "Golden Kris",
                "Steel Circlet",
                "Butcher Knife",
                "Embroidered Gloves"
            };
            return Int;
        }

        public static string[] Str()
        {
            string[] Str = new string[] {
                "Astral",
                "Tower",
                "Burgonet",
                "Ancient",
                "Fencer",
                "Goliath",
                "Pig-Faced",
                "Crusader Boots",
                "Vaal Gauntlets",
                "Prophet Crown",
                "Antique Greaves",
                "Vaal Greaves",
                "Siege Helmet",
                "Reinforced Greeves",
                "Soldier Boots",
                "Aventail Helmet",
                "Reaver Helmet",
                "Saint's Hauberk",
                "Samnite Helmet"
            };
            return Str;
        }

        public static string[] Dex()
        {
            string[] Dex = new string[] {
                "Claw",
                "Bow",
                "Quiver",
                "Deerskin",
                "Ambusher",
                "Wyrnmscale",
                "Gouger",
                "Dagger",
                "Spiked",
                "Hood",
                "Ursine",
                "Oak",
                "Carnal",
                "Vaal Buckler",
                "Nightmare Bascinet",
                "Poignard",
                "Gutting Knife",
                "Vaal Mask",
                "Throat Stabber",
                "Lion Pelt",
                "Stealth Gloves",
                "Battle Buckler",
                "Shagreen Boots",
                "Shagreen Gloves",
                "Sharkskin Gloves",
                "Enameled Buckler",
                "Corsair Sword"

            };
            return Dex;
        }

        public static void Gen(string section, int tierValue, bool tier1HAxe, bool tier2HAxe, bool tierBow, bool tierClaw, bool tierDagger, bool tier1HMace, bool tier2HMace, bool tierSceptre, bool tierStaff, bool tier1HSword, bool tier2HSword, bool tierWand, bool tierBody, bool tierBoots, bool tierGloves, bool tierHelmet, bool tierShield, bool tierQuiver, List<string> tierBaseInclude, List<string> tierBaseExclude)
        {
            var ln = JsonConvert.DeserializeObject<Root>(File.ReadAllText("data/ninja.base.json", Encoding.UTF8));

            ForEachLine(ln, "One Handed Axe", tier1HAxe, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Two Handed Axe", tier2HAxe, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Bow", tierBow, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Claw", tierClaw, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Dagger", tierDagger, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "One Handed Mace", tier1HMace, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Two Handed Mace", tier2HMace, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Sceptre", tierSceptre, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Staff", tierStaff, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "One Handed Sword", tier1HSword, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Two Handed Sword", tier2HSword, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Wand", tierWand, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Body Armour", tierBody, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Boots", tierBoots, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Gloves", tierGloves, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Helmet", tierHelmet, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Shield", tierShield, section, tierValue, tierBaseInclude, tierBaseExclude);
            ForEachLine(ln, "Quiver", tierQuiver, section, tierValue, tierBaseInclude, tierBaseExclude);
        }

        public static void ForEachLine(dynamic lnb, string type, bool tierBool, string section, int tierValue, List<string> tierBaseInclude, List<string> tierBaseExclude)
        {
            int c = 0;
            List<string> stringList = new List<string>();
            var ln = JsonConvert.DeserializeObject<Root>(File.ReadAllText("data/ninja.base.json", Encoding.UTF8));
            foreach (var line in ln.lines)
            {
                string[] cint = Int();
                string[] cstr = Str();
                string[] cdex = Dex();
                if (line.itemType == type && tierBool && line.levelRequired <= 86 && line.variant == null && line.chaosValue >= tierValue && !stringList.Contains(line.baseType))
                {
                    if (!tierBaseExclude.Contains(line.baseType))
                    {
                        c++;
                        iBA.Add(line.baseType);
                        if (cint.Any(line.baseType.Contains))
                        {
                            iBIntA.Add(line.baseType);
                            iBA.Remove(line.baseType);
                        }
                        if (cstr.Any(line.baseType.Contains))
                        {
                            iBStrA.Add(line.baseType);
                            iBA.Remove(line.baseType);
                        }
                        if (cdex.Any(line.baseType.Contains))
                        {
                            iBDexA.Add(line.baseType);
                            iBA.Remove(line.baseType);
                        }
                        stringList.Add(line.baseType);
                    }
                }
                else if (line.itemType == type && !tierBool && line.levelRequired <= 86 && line.variant == null && line.chaosValue >= tierValue && tierBaseInclude.Contains(line.baseType) && !stringList.Contains(line.baseType))
                {
                    c++;
                    iBA.Add(line.baseType);
                    if (cint.Any(line.baseType.Contains))
                    {
                        iBIntA.Add(line.baseType);
                        iBA.Remove(line.baseType);
                    }
                    if (cstr.Any(line.baseType.Contains))
                    {
                        iBStrA.Add(line.baseType);
                        iBA.Remove(line.baseType);
                    }
                    if (cdex.Any(line.baseType.Contains))
                    {
                        iBDexA.Add(line.baseType);
                        iBA.Remove(line.baseType);
                    }
                    stringList.Add(line.baseType);
                }                
            }

            foreach (string b in iBA)
            {
                iB += string.Format(@" ""{0}""", b);
            }

            foreach (string b in iBIntA)
            {
                iBInt += string.Format(@" ""{0}""", b);
            }

            foreach (string b in iBStrA)
            {
                iBStr += string.Format(@" ""{0}""", b);
            }

            foreach (string b in iBDexA)
            {
                iBDex += string.Format(@" ""{0}""", b);
            }

            if (c != 0)
            {
                if (iBA.Count >= 1) { GenerateFile(section, iB, type, "Base", "    SetBackgroundColor 54 54 54 255"); }
                if (iBIntA.Count >= 1) { GenerateFile(section, iBInt, type, "Int", "    SetBackgroundColor 56 69 89 255"); }
                if (iBStrA.Count >= 1) { GenerateFile(section, iBStr, type, "Str", "    SetBackgroundColor 81 54 54 255"); }
                if (iBDexA.Count >= 1) { GenerateFile(section, iBDex, type, "Dex", "    SetBackgroundColor 50 69 49 255"); }                            
            }                     
            c = 0;
            iBA = new List<string>();
            iBIntA = new List<string>();
            iBStrA = new List<string>();
            iBDexA = new List<string>();
            iB = "";
            iBInt = "";
            iBStr = "";
            iBDex = "";
        }

        public static void GenerateFile(string section, string iB, string type, string att, string SetBackgroundColor)
        {
            if (iB == null || iB == "")
                iB = "\"\"";
            string path = "gen/" + section + ".filter";
            File.AppendAllText(path, $"# Section: {section} ({type})({att})" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    HasExplicitMod \"Veiled\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 112 255 112 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    MinimapIcon 1 Green Star" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    PlayEffect Green" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    FracturedItem True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 112 255 112 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    MinimapIcon 1 Green Star" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    PlayEffect Green" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SynthesisedItem True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 112 255 112 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    MinimapIcon 1 Green Star" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    PlayEffect Green" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Identified True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 0 0 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Corrupted True" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 210 0 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    ItemLevel >= 75" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    ItemLevel <= 100" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 184 218 242" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    ItemLevel >= 60" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    ItemLevel <= 74" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 222 118 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    ItemLevel >= 60" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    ItemLevel <= 74" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetTextColor 255 215 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, SetBackgroundColor + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBorderColor 222 118 0" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
        }
    }
}
